/*
	ļmain.c
	  ܣLuckyProg2004λ̿
	Ӳ  :	CA-M8(ChipArt-Mega8)
	  : WinAVR-20040404
	ʱ  ӣⲿ4MHz
	
	ļ¼
	2004-11-20      	
*/
#include <avr/io.h>
#include <avr/delay.h>
#include <avr/signal.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>

#include "usart.h"
#include "lp2004.h"

#define FREQ 4		//ϵͳʱ(MHz)
#define DEVICE_ID 0X33	//ID

#define SET_RED_LED PORTB&=~_BV(PB1)
#define CLR_RED_LED PORTB|=_BV(PB1)

#define SET_YEL_LED PORTB&=~_BV(PB0)
#define CLR_YEL_LED PORTB|=_BV(PB0)

uchar g_aCommand[5];	//
uchar g_aConfigBits[4];//λ壬Բ

//̼Ϣݣ24ֽڣ
const char g_firmmsg[] PROGMEM = "о    QQ:27796915     ";

//ʱ t ms
void DelayMs(uint t)
{
	uint i;
	for(i=0;i<t;i++)
		_delay_loop_2(FREQ * 250);
}

//Ӧ
void ack()
{
	uchar *p=UartGetBuffer();
	p[0]=LP_ACK;
	UartSend(1);
}

//ʱ⹦ܵUART
uchar UartRecvEx(uint len,uint timeout)
{
	uint count=0;
	UartRecv(len,UART_NO_WAIT);
	while(1)
	{
		count++;
		DelayMs(1);
		if(UartIsRecvComplate())
			return 1;
		if(count>=timeout)
			return 0;
	}
}
//LP_WRITE_FLASH
void WriteFlash(void)
{
	uint i;
	uint PacketCount=g_aCommand[1]+(g_aCommand[2]<<8);
	
	for(i=0;i<PacketCount;i++)
	{
		ack();
		if(!UartRecvEx(LP_PACKET_SIZE,2000))
			break;
		//뽫滻ΪдFLASHĴ
		DelayMs(100);
	}
	ack();
	//UART_PACKET_SIZE
}
//LP_READ_FLASH
void ReadFlash(void)
{
	uint i;
	uchar j,*p;
	uint PacketCount=g_aCommand[1]+(g_aCommand[2]<<8);
	p=UartGetBuffer();
	
	ack();
	
	for(i=0;i<PacketCount;i++)
	{
		if(!UartRecvEx(1,2000))
			break;
		//뽫滻ΪFALSHĴ
		for(j=0;j<LP_PACKET_SIZE;j++)
			p[j]=0x88;
			
		UartSend(LP_PACKET_SIZE);
	}
}
//LP_WRITE_EEPROM
void WriteEeprom(void)
{
	uint i;
	uint PacketCount=g_aCommand[1]+(g_aCommand[2]<<8);
	
	for(i=0;i<PacketCount;i++)
	{
		ack();
		if(!UartRecvEx(LP_PACKET_SIZE,2000))
			break;
		//뽫滻ΪдEEPROMĴ
		DelayMs(100);
	}
	ack();
}
//LP_READ_EEPROM
void ReadEeprom(void)
{
	uint i;
	uchar j,*p;
	uint PacketCount=g_aCommand[1]+(g_aCommand[2]<<8);
	p=UartGetBuffer();
	
	ack();
	
	for(i=0;i<PacketCount;i++)
	{
		if(!UartRecvEx(1,2000))
			break;
		//뽫滻ΪEEPROMĴ
		for(j=0;j<LP_PACKET_SIZE;j++)
			p[j]=0x99;
			
		UartSend(LP_PACKET_SIZE);
	}	
}
//LP_WRITE_BITS
void WriteBits(void)
{
	g_aConfigBits[0]=g_aCommand[1];	
	g_aConfigBits[1]=g_aCommand[2];
	g_aConfigBits[2]=g_aCommand[3];
	g_aConfigBits[3]=g_aCommand[4];
	//ڴдλ
	ack();
}
//LP_READ_BITS
void ReadBits(void)
{
	uchar *p;
	p=UartGetBuffer();
	
	//ڴλ
	p[0]=LP_READ_BITS;
	p[1]=g_aConfigBits[0];
	p[2]=g_aConfigBits[1];
	p[3]=g_aConfigBits[2];
	p[4]=g_aConfigBits[3];
	UartSend(5);
}
//LP_ERASE_DEVICE
void EraseDevice(void)
{
	//ڴĴ
	ack();
}
//LP_RESET_DEVICE
void ResetDevice(void)
{
	//ڴ븴λĴ
	ack();
}
//LP_READ_FIRMWARE_MSG
void ReadFirmwareMsg(void)
{
	uchar i;
	uchar *p=UartGetBuffer();
	for(i=0;i<24;i++)
		p[i]=pgm_read_byte(g_firmmsg+i);
	UartSend(24);
}
//ں
int main(void)
{
	uchar i;
	uchar *p=UartGetBuffer();
	
	DDRB=_BV(PB0)|_BV(PB1);
	PORTB=0X03;
	
	UartInit();
	sei();
	
	while(1)
	{
		CLR_RED_LED;
		SET_YEL_LED;
		//ID ظ
		UartRecv(1,UART_WAIT);
		CLR_YEL_LED;
		SET_RED_LED;
		if(p[0]==DEVICE_ID)
		{
			ack();
		}
		else if(p[0]==LP_ACK)//LP_SCAN_HARDWAR
		{
			ack();		
			continue;
		}
		else
		{
			continue;
		}
		
		//
		if(!UartRecvEx(5,2000))
			continue;
		for(i=0;i<5;i++)
			g_aCommand[i]=p[i];

		switch(g_aCommand[0])
		{
		case LP_WRITE_FLASH:
			WriteFlash();
			break;
		case LP_READ_FLASH:
			ReadFlash();
			break;
		case LP_WRITE_EEPROM:
			WriteEeprom();
			break;
		case LP_READ_EEPROM	:
			ReadEeprom();
			break;
		case LP_ERASE_DEVICE:
			EraseDevice();
			break;
		case LP_WRITE_BITS  :
			WriteBits();
			break;
		case LP_READ_BITS:
			ReadBits();
			break;
		case LP_RESET_DEVICE:
			ResetDevice();
			break;
		case LP_READ_FIRMWARE_MSG:
			ReadFirmwareMsg();
			break;
		default:
			break;
		}//switch
	}//while(1)
}//main
