// ComPort.cpp: implementation of the CComPort class.
//	о (c) copyright 2004
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ComPort.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CComPort::CComPort()
{
	m_nCurrentCom=0;
	memset(&m_ovRead,0,sizeof(OVERLAPPED));
	memset(&m_ovWrite,0,sizeof(OVERLAPPED));
}

CComPort::~CComPort()
{
	m_strLastError.Empty();
}

BOOL CComPort::Open(int portnum)
{
	//Ҫ򿪵Ķ˿ں뵱ǰ򿪵Ķ˿ͬ,
	if(m_nCurrentCom==portnum)
		return TRUE;

	Close();//رյǰ˿
	m_strLastError.Empty();

	if(m_ovRead.hEvent)
		ResetEvent(m_ovRead.hEvent);
	else
		m_ovRead.hEvent=CreateEvent(NULL,TRUE,FALSE,NULL);

	if(m_ovRead.hEvent==NULL)
		return FALSE;

	if(m_ovWrite.hEvent)
		ResetEvent(m_ovWrite.hEvent);
	else
		m_ovWrite.hEvent=CreateEvent(NULL,TRUE,FALSE,NULL);
	if(m_ovWrite.hEvent==NULL)
		return FALSE;

	COMMTIMEOUTS TimeOuts;
	DCB dcb;
	CString strCom;
	strCom.Format("COM%d",portnum);

	m_hCom=CreateFile(strCom								//˿ڷ
		,GENERIC_READ|GENERIC_WRITE							//:д
		,0													//
		,NULL												//ްȫ
		,OPEN_EXISTING										//ִļ,򷵻ʧ
		,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_OVERLAPPED			//ص
		,NULL												//޴
		);

	if(m_hCom==INVALID_HANDLE_VALUE)
		return FALSE;

	SetupComm(m_hCom,1024,1024);//

	/*
	ڴнʱֽڵʱĳʱ
	ReadFileеһֽڵЧ
	0Ϊʹ
	*/
	TimeOuts.ReadIntervalTimeout=MAXWORD;

	/*
	ĸöдܳʱʱ	
	ܳʱʱ㷽:
	ReadTotalTimeoutConstant+(ReadTotalTimeoutMultiplier*ֽ)
	дƶ
	*/
	/*ʱΪ0,ʹReadFile*/
	TimeOuts.ReadTotalTimeoutConstant=0;
	TimeOuts.ReadTotalTimeoutMultiplier=0;

	TimeOuts.WriteTotalTimeoutConstant=2000;
	TimeOuts.WriteTotalTimeoutMultiplier=50;

	SetCommTimeouts(m_hCom, &TimeOuts);//óʱ

	if(!GetCommState(m_hCom,&dcb))
	{
		Close();
		return FALSE;
	}
	dcb.fBinary=TRUE;//Ʒʽ,WINDOWS APIִֻ֧˷ʽ
	dcb.BaudRate=9600;
	dcb.ByteSize=8;
	dcb.fParity=FALSE;//Уֹ

	SetCommState(m_hCom,&dcb);

	m_nCurrentCom=portnum;
	return TRUE;
}

void CComPort::Close()
{
	if(m_nCurrentCom)
		CloseHandle(m_hCom);
	m_nCurrentCom=0;
}

//ͬд
UINT CComPort::Write(UCHAR *buf, UINT len)
{
	DWORD length=len;
	COMSTAT ComStat;
	DWORD dwErrorFlags;

	ClearCommError(m_hCom,&dwErrorFlags,&ComStat);
	
	if(WriteFile(m_hCom,buf,length,&length,&m_ovWrite)==0)
	{
		if(GetLastError()==ERROR_IO_PENDING)
		{
			GetOverlappedResult(m_hCom,&m_ovWrite,&length,TRUE);// ȴ
		}
		else
			length=0;
	}
	return length;
}

//첽ȡ أ0:ɹ 1:ʱ 2:I/O [3:ûȡ,pEvent[1]ûȡ¼ʱ]
UINT CComPort::Read(UCHAR *buf, UINT len , DWORD timeout)
{
	DWORD WaitResult;
	HANDLE pEvent[2];

	pEvent[0]=m_ovRead.hEvent;

	DWORD length;
	ClearCommError(m_hCom,&length,NULL);
	length=0;
	ResetEvent(m_ovRead.hEvent);

	if(!ReadFile(m_hCom,buf,len,&length,&m_ovRead))
	{
		if(GetLastError()==ERROR_IO_PENDING) //ص
		{
			//ȴݡȡͳʱ
			WaitResult=WaitForMultipleObjects(1,pEvent,FALSE,timeout);
			if(WaitResult==0)
			{
				GetOverlappedResult(m_hCom, &m_ovRead,&length, FALSE) ; 
				m_strLastError.Empty();
			}
			else if(WaitResult==WAIT_TIMEOUT)//ʱ
			{
				m_strLastError="\r\nͨųʱ";
				return 1;
			}
			else if(WaitResult==WAIT_FAILED)
			{
				m_strLastError="\r\nǰ˿ڲ";
				return 2;
			}

		}
		else//I/O
		{
			m_strLastError="\r\nǰ˿ڲ";
			return 2;
		}
	}
	return 0;
}

void CComPort::GetError(CString &str)
{
	str=m_strLastError;
	m_strLastError.Empty();
}

void CComPort::ClearBuffer()
{
	if(m_nCurrentCom>0)
		PurgeComm(m_hCom,PURGE_TXCLEAR|PURGE_RXCLEAR|PURGE_RXABORT);
}
