/*
	LuckyProg2004 Mega8 BootLoader  	
		
	ļ	:	demo.c
	    : 	о 
	ʱ:	2004-11-16
	
	CPU 	:	ATMEGA8
	ʱ    :	ⲿ4MHz
	    :	WinAVR-20040720	
	
	E-mail	:	changfutong@sina.com
	MSN		:	changfutong@hotmail.com
	OICQ	:	27796915
	ӭ: 	http://bitfu.zj.com    http://BitFu.yeah.net
	

	ע:CA-M8ʵϵͨ,
	LuckyProg2004 ʹá

*/

#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>
#include <avr/boot.h>

#include "lp2004.h"

#define uchar unsigned char
#define uint unsigned int

#define FREQ 4
//ݰóM8ҳȣֽڣ
//PAGE_SIZE == LP_PACKET_SIZE
#define PAGE_SIZE 64
#define DEVICE_ID 8
#define MAX_PAGE_COUNT 96


#define SET_RED_LED PORTB&=~_BV(PB1)
#define CLR_RED_LED PORTB|=_BV(PB1)

#define SET_YEL_LED PORTB&=~_BV(PB0)
#define CLR_YEL_LED PORTB|=_BV(PB0)

uint g_wPageIndex=0;			//дҳ	
uchar g_aPageTemp[PAGE_SIZE];	//ݰ
uchar g_aCommand[5];			//

void (*reset)(void)=0x0000;

void uart_putc(uchar c)
{
	while( !(UCSRA & (1<<UDRE)) );
	UDR=c;
}

uchar uart_getc(void)
{
	while( !(UCSRA & (1<<RXC)) );	
	return UDR;
}
//дflash
void WriteFlash(void)
{
	uchar i;
	uint PageCount=g_aCommand[2];
	PageCount<<=8;
	PageCount+=g_aCommand[1];
	for(g_wPageIndex=0;g_wPageIndex<PageCount;g_wPageIndex++)
	{
		uart_putc(LP_ACK);
		//	յǰҳ
		for(i=0;i<PAGE_SIZE;i++)
			g_aPageTemp[i]=uart_getc();
		//6KϵĲд
		if(g_wPageIndex<MAX_PAGE_COUNT)
		{
			//	ҳ
		    boot_page_erase(g_wPageIndex<<6);
		    while(boot_rww_busy())
		        boot_rww_enable();
		
			//	仺ҳ
		    for(i = 0; i < PAGE_SIZE; i += 2)
		        boot_page_fill((unsigned long)i,*((uint *)(g_aPageTemp +i)));
		
		    //	ҳд
		    boot_page_write(g_wPageIndex<<6);
		    while(boot_rww_busy())
		        boot_rww_enable();
	    }
   
	}
	uart_putc(LP_ACK);
}
//flash
void ReadFlash(void)
{
    uchar i;
	uint PageCount=g_aCommand[2];
	PageCount<<=8;
	PageCount+=g_aCommand[1];
	uart_putc(LP_ACK);
	for( g_wPageIndex=0;g_wPageIndex<PageCount;g_wPageIndex++)
	{   
		uart_getc();
		if(g_wPageIndex<MAX_PAGE_COUNT)
		{
    		for(i=0;i<PAGE_SIZE;i++)
    			uart_putc(pgm_read_byte(i+(g_wPageIndex*PAGE_SIZE)));
    	}
    	else//6Kϵҳ
    	{
    		for(i=0;i<PAGE_SIZE;i++)
    			uart_putc(0xff);
    	}
	}
	
}
//дeeprom
void WriteEeprom(void)
{
	uchar i;
	uint PageCount=g_aCommand[2];
	PageCount<<=8;
	PageCount+=g_aCommand[1];
	for(g_wPageIndex=0;g_wPageIndex<PageCount;g_wPageIndex++)
	{
		uart_putc(LP_ACK);
		//	ҳ
		for(i=0;i<PAGE_SIZE;i++)
			g_aPageTemp[i]=uart_getc();	
			
		 eeprom_write_block (g_aPageTemp,PAGE_SIZE *g_wPageIndex, PAGE_SIZE); 	
	}
	uart_putc(LP_ACK);
}
//eeprom
void ReadEeprom(void)
{
	uchar i;
	uint PageCount=g_aCommand[2];
	PageCount<<=8;
	PageCount+=g_aCommand[1];
	uart_putc(LP_ACK);
	for( g_wPageIndex=0;g_wPageIndex<PageCount;g_wPageIndex++)
	{   
		uart_getc();

		for(i=0;i<PAGE_SIZE;i++)
			uart_putc(eeprom_read_byte(i+(g_wPageIndex*PAGE_SIZE)));
    }	
}
int  main(void) 
{
	uchar tmp;
	
	DDRB=_BV(PB0)|_BV(PB1);
	PORTB=0X03;	
	//uart ʼ
	UBRRH=0;
	UBRRL=25;//9600 baud 4MHz:25
	UCSRB=_BV(RXEN)|_BV(TXEN);
	
	while(1)
	{
		SET_YEL_LED;
		CLR_RED_LED;
		tmp=uart_getc();
		if(tmp==LP_ACK)
		{	
			uart_putc(LP_ACK);
			continue;
		}
		else if(tmp!=DEVICE_ID)
			continue;
		uart_putc(LP_ACK);
		SET_RED_LED;
		CLR_YEL_LED;
		for(tmp=0;tmp<5;tmp++)
			g_aCommand[tmp]=uart_getc();
			
		switch(g_aCommand[0])
		{
		case LP_WRITE_FLASH	:
			WriteFlash();
			break;	
		case LP_READ_FLASH	:
			ReadFlash();
			break;
		case LP_WRITE_EEPROM:
			WriteEeprom();
			break;		
		case LP_READ_EEPROM:
			ReadEeprom();
			break;		
		case LP_ERASE_DEVICE:
			uart_putc(LP_ACK);
			break;		
		case LP_WRITE_BITS:
			break;  		
		case LP_READ_BITS:
			break;   		
		case LP_SCAN_HARDWAR:
			break;		
		case LP_RESET_DEVICE:
			uart_putc(LP_ACK);
			reset();
			break;		
		default:
			break;
		}
	
	}	
}	


