/*
	LuckyProg Mega8 BootLoader  V1.0	
		
	ļ	:	demo.c
	    : 	о 
	ʱ:	2004-08-30
	
	CPU 	:	ATMEGA8
	ʱ    :	4MHz
	    :	WinAVR-20040720	
	
	E-mail	:	changfutong@sina.com
	MSN		:	changfutong@hotmail.com
	OICQ	:	27796915
	ӭ: http://BitFu.yeah.net
	

	ע:Ӳϵͨ,
	LuckyProg Mega8 BootLoader(LuckyProg M8BL)V1.0ʹá

*/

#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/boot.h>

#define uchar unsigned char
#define uint unsigned int

#define FREQ 4
#define UART_ACK 0XAA

#define PAGE_SIZE 64

uint g_wPageIndex=0;		//
uchar g_aPageTemp[PAGE_SIZE];

void (*reset)(void)=0x0000;

void uart_putc(uchar c)
{
	while( !(UCSRA & (1<<UDRE)) );
	UDR=c;
}

uchar uart_getc(void)
{
	while( !(UCSRA & (1<<RXC)) );	
	return UDR;
}

void WritePage(void)
{
	uchar i;
	
	//	յǰҳ
	for(i=0;i<PAGE_SIZE;i++)
		g_aPageTemp[i]=uart_getc();
	
	//	ҳ
    boot_page_erase(g_wPageIndex<<6);
    while(boot_rww_busy())
        boot_rww_enable();

	//	仺ҳ
    for(i = 0; i < PAGE_SIZE; i += 2)
        boot_page_fill((unsigned long)i,*((uint *)(g_aPageTemp +i)));

    //	ҳд
    boot_page_write(g_wPageIndex<<6);
    while(boot_rww_busy())
        boot_rww_enable();
    
    g_wPageIndex++;
}

void ReadPage(void)
{
    uchar i;
    
    for(i=0;i<PAGE_SIZE;i++)
    	uart_putc(pgm_read_byte(i+(g_wPageIndex*PAGE_SIZE)));

	g_wPageIndex++;
}

int  main(void) 
{
	uchar tmp;
	

	//uart ʼ
	UBRRH=0;
	UBRRL=25;//9600 baud 6MHz:38  4MHz:25
	UCSRB=(1<<RXEN)|(1<<TXEN);
	
	while(1)
	{
		tmp=uart_getc();//recv command
		
		
		switch(tmp)
		{
			case 0xB0://ҳַ
				g_wPageIndex=uart_getc();
				uart_putc(g_wPageIndex);
				break;
				
			case 0xBF://û
				reset();
				break;
				
			case 0xAF://дһҳ
				WritePage();
				uart_putc(UART_ACK);//Ӧ
				break;
				
			case 0xA0://һҳ
				ReadPage();
				break;
				
			case UART_ACK://Ӧ
				uart_putc(UART_ACK);
				break;
			
			default:
				break;
		}
	
	}	
}	


