/*
	Mega8 ӲTWIӿڶдʵʱʱDS1307
	ļmain.c
	
	о 2004-09-02   ---------- 2004-09-07
*/


#include <avr/io.h>
#include <avr/delay.h>
#include <avr/twi.h>
#include <avr/pgmspace.h>

#include <stdio.h>

#define uint unsigned int
#define uchar unsigned char

#define FREQ 4
#define DS1307_ADDR 0XD0

#define TW_ACK  1
#define TW_NACK 0

#define RTC_READ 1
#define RTC_WRITE 0


FILE *g_hFile;

uchar g_aTimeBuf[7];///ʱBCDʽ
uchar g_aTimeBin[7];//ʱ/Ƹʽ

void DelayMs(uint ms)
{
	uint i;
	for(i=0;i<ms;i++)
		_delay_loop_2(FREQ *250);
}


/*******************׼I/O****************ʼ********/
//׼I/O
int usart_putchar(char c)
{
	if(c=='\n')
		usart_putchar('\r');
	loop_until_bit_is_set(UCSRA,UDRE);
	UDR=c;
	return 0;
}
//׼I/O뺯
int usart_getchar(void)
{
	loop_until_bit_is_set(UCSRA,RXC);
	return UDR;
}

//ʼ
void IoInit(void)
{
	DDRC=0;
	PORTC=_BV(PC5)|_BV(PC4);//迪
	
	//пڳʼ
	UCSRB=_BV(RXEN)|_BV(TXEN);/*(1<<RXCIE)|(1<<TXCIE)|*/
	UBRRL=25;	//9600 baud 6MHz:38  4MHz:25	
	
	//UARTڱ׼I/O
	g_hFile=fdevopen(usart_putchar,usart_getchar,0);	
}
/*******************׼I/O************************/

/*************ģʽTWI*************ʼ**************/

//ֹͣ
void twi_stop(void)
{
	TWCR = _BV(TWINT) | _BV(TWSTO) | _BV(TWEN);
}
//𶯿ʼ
uchar twi_start(void)
{
	TWCR = _BV(TWINT) | _BV(TWSTA) | _BV(TWEN); 
	while ((TWCR & _BV(TWINT)) == 0) ;

	
	return TW_STATUS;
}

//дһֽ
uchar twi_writebyte(uchar c)
{
	TWDR = c;
	TWCR = _BV(TWINT) | _BV(TWEN); 	
	while ((TWCR & _BV(TWINT)) == 0);
	return TW_STATUS;
}

//һֽ ack: trueʱACKfalseʱNACK
uchar twi_readbyte(uchar *c ,uchar ack)
{
	uchar tmp=_BV(TWINT)|_BV(TWEN);
		
	if(ack)
		tmp|=_BV(TWEA); 	
	TWCR=tmp;
	while ((TWCR & _BV(TWINT)) == 0) ;

	*c=TWDR;

	return TW_STATUS;
}
/*************ģʽTWI***************************/

/*************DS1307**************ʼ**************/
//DS1307ڴд
uchar rtc_write(uchar addr,uchar *buf,uchar len)
{
	uchar i;
	
	twi_start();
	twi_writebyte(DS1307_ADDR|TW_WRITE);
	twi_writebyte(addr);//write address
	for(i=0;i<len;i++)
		twi_writebyte(buf[i]);
	twi_stop();
	return 0;
}

//DS1307ڴĶ
uchar rtc_read(uchar addr,uchar *buf,uchar len)
{
	uchar i;
	
	rtc_write(addr,0,0);//set address
	
	DelayMs(10);
	
	twi_start();
	twi_writebyte(DS1307_ADDR|TW_READ);
	for(i=0;i<len-1;i++)
		twi_readbyte(buf+i,TW_ACK);
	twi_readbyte(buf+i,TW_NACK);

	twi_stop();
	return 0;
}
/*************DS1307****************************/

/*************ӿڲ****************ʼ**************/

//ʼTWI
void RtcInit(void)
{
	TWBR=73;
}

//»ȡDS1307/ʱ
uchar RtcUpdateData(uchar direction)
{
	uchar ret;
	if(direction)	//
		ret=rtc_read(0,g_aTimeBuf,7);
	else			//д
		ret=rtc_write(0,g_aTimeBuf,7);	

	return ret;
}
//DS1307ûRAM
uchar RtcReadRAM(uchar addr,uchar *buf,uchar len)
{
	addr+=8;
	return rtc_read(addr,buf,len);
}
//дDS1307ûRAM
uchar RtcWriteRAM(uchar addr,uchar *buf,uchar len)
{
	addr+=8;
	return rtc_write(addr,buf,len);
}

uchar byte_bintobcd(uchar bin)
{
	uchar ret;
	bin&=0x7f;
	bin%=100;
	ret=bin/10;
	ret <<=4;
	ret|=bin%10;
	return ret;
}
uchar byte_bcdtobin(uchar bcd)
{
	uchar ret;
	ret=bcd & 0x0f;
	ret+=(bcd>>4)*10;
	return ret;		
}

//Ƹʽ(g_aTimeBin)תBCDʽ󱣴浽BCDʽ(g_aTimeBuf)
void RtcBinToBCD()
{
	uchar i;
	g_aTimeBin[0]&=0x7f;
	g_aTimeBin[1]&=0x7f;
	g_aTimeBin[2]&=0x3f;
	g_aTimeBin[3]&=0x07;
	g_aTimeBin[4]&=0x3f;
	g_aTimeBin[5]&=0x1f;	
	g_aTimeBin[6]&=0xff;
	
	for(i=0;i<7;i++)
		g_aTimeBuf[i]=byte_bintobcd(g_aTimeBin[i]);
}

//BCDʽ(g_aTimeBuf)תɶƸʽ󱣴浽Ƹʽ(g_aTimeBin)
void RtcBCDToBin()
{
	uchar i;
	for(i=0;i<7;i++)
		g_aTimeBin[i]=byte_bcdtobin(g_aTimeBuf[i]);
}

//дDS1307ֽ
void RtcSetSQWOutput(uchar en,uchar level)
{
	//en: TRUE Ч level:ֹ OUTڵ߼ƽ
	uchar c=0;
	if(en)	//enable
		c=0x10;
	else	//disable
	{
		if(level)
			c=0x80;
	}
	rtc_write(7,&c,1);
}
/*************ӿڲ*****************************/

int main(void)
{
	uchar i;
	char c;
	int tmp[7];//ӱ׼I/Oȡ
	
	IoInit();
	RtcInit();
	
	printf_P(PSTR("g - ӡ/ʱӣs - /ʱӣh - Ϣ\n"));	
	
	while(1)
	{
		scanf("%c",&c);
		if(c=='g')
		{
			RtcUpdateData(RTC_READ);
			RtcBCDToBin();
			
			printf_P(PSTR("ǰ/ʱӣ%d%d%d %d  %d:%d:%d\n"),g_aTimeBin[6],g_aTimeBin[5],g_aTimeBin[4],g_aTimeBin[3],g_aTimeBin[2],g_aTimeBin[1],g_aTimeBin[0]);
		}
		else if(c=='s')
		{
			printf_P(PSTR("밴 <     Сʱ   > ʽ룺\n"));
			scanf("%d,%d,%d,%d,%d,%d,%d",tmp+6,tmp+5,tmp+4,tmp+3,tmp+2,tmp+1,tmp);
			
			for(i=0;i<7;i++)
				g_aTimeBin[i]=(uchar)tmp[i];
	
			RtcBinToBCD();
			RtcUpdateData(RTC_WRITE);
			
			printf_P(PSTR("\n!\n"));
		}
		else if(c=='h')
			printf_P(PSTR("g - ӡ/ʱӣs - /ʱӣh - Ϣ\n"));	
		else
			continue;
	}
	return 0;
}
